﻿#####################
#### © by Stirni ####
#####################


###########################
#                         #
#     START OF CONFIG     #
#                         #
###########################


# ================================
# >> SaySounds Config
# ================================



# >> s_saysounds
""" Say Sounds On or Off?  1 = ON | 0 = OFF """
s_saysounds = 1


# >> General information ; s_yourdirectory_saysounds
""" If s_saysounsd is ON: """
""" Music directory is ../orangebox/cstrike/sound/s_sounds/saysounds/<your directory>/ """
""" e.g. ../orangebox/cstrike/sound/s_sounds/saysounds/saysounds_by_stirni/ by default """
""" If you want my say sounds, let it by default """
s_yourdirectory_saysounds = "saysounds_by_stirni"


""" All SaySounds you put in here: ../orangebox/cstrike/sound/s_sounds/saysounds/<your directory>/ """
""" will automatically be added. There is no need to add them to a list or another file. | Very comfortably """

# >> s_howoften
""" How often can you play sounds per round? 1 = Once; 2 = Twice; 3 = Three Times; ... """
s_howoften = 2


# >> s_saysoundlist
""" Which commands do you want to, to popup the SaySoundlist? """
""" If you only want one command, delete the second one. If you want more than 2, add one more ;) """
""" Example: 1 command: s_saysoundlist = ("!saysounds")  ; 3 Commands: s_saysoundlist = ("!saysounds", "/saysounds", "\saysounds") """
s_saysoundlist = "!saysounds"


# >> s_saysoundsettings
""" Command to open the saysounds settings handler - its a popup ;) """
""" Same as above. 2 commands now. you can add/remove them """
s_saysoundsettings = "!saysoundsmenu"


# >> Caution
""" Caution: All folders and soundfiles must exist! """
""" Last word to SaySounds: """
""" I implemented a AntiSpamFilter, that means, you can only play a sound, if no other is played at the same time """



# ================================
# >> RoundEndSounds Config
# ================================



# >> s_roundendsounds
""" RoundEndSound On or Off?  1 = ON | 2 = OFF """
s_roundendsounds = 1


# >> General information ; s_yourdirectory_roundendsounds
""" If s_roundendsounds is ON: """
""" Music directory is ../orangebox/cstrike/sound/s_sounds/roundendsounds/<your directory>/ """
""" e.g. ../orangebox/cstrike/sound/s_sounds/roundendsounds/resounds_by_stirni/ by default """
""" If you want my round end sounds, let it by default. """
s_yourdirectory_roundendsounds = "roundendsounds_by_stirni"


""" All RoundEndSounds you put in here: ../orangebox/cstrike/sound/s_sounds/roundendsounds/<your directory>/ """
""" will automatically be added. There is no need to add them to a list or another file. | Very comfortably """


# >> s_ressettings
""" Command to open the round end sounds settings handler - its a popup ;) """
""" 2 commands. you can add/remove them. same as above. """
s_ressettings = "!res"


# >> Mode explainations:
""" Mode: Some explainations ;) """

# >> Mode 1:
""" Mode 1 to be called whenever  s_mode = 1 : """
""" All sounds in ../orangebox/cstrike/sound/s_sounds/roundendsounds/<your directory>/ """
""" and           ../orangebox/cstrike/sound/s_sounds/roundendsounds/<your directory>/CT/ """
""" and           ../orangebox/cstrike/sound/s_sounds/roundendsounds/<your directory>/T/ """
""" will be used to generate 1 random sound to be played at round end """

# >> Mode 2:
""" Mode 2 to be called whenever  s_mode = 2 : """
""" If winnerteam is CT, the script will generate 1 random sound from """
""" ../orangebox/cstrike/sound/s_sounds/roundendsounds/<your directory>/CT/ """
""" to be played at round end """
""" If winnerteam is T, the script will generate 1 random sound from """
""" ../orangebox/cstrike/sound/s_sounds/roundendsounds/<your directory>/T/ """
""" to be played at round end """

# >> Mode 3:
""" Mode 3 to be called whenever  s_mode = 3 : """
""" In this mode, the script will only generate 1 random sound from """
""" ../orangebox/cstrike/sound/s_sounds/roundendsounds/<your directory>/ """
""" to be played at round end """
"""     ../orangebox/cstrike/sound/s_sounds/roundendsounds/<your directory>/CT/ """
""" and ../orangebox/cstrike/sound/s_sounds/roundendsounds/<your directory>/T/ """
""" ARE NOT INCLUDED! """
""" If  s_mode = 2  and neither CT nor T wins, the script will generate a random """
""" sound like it is in Mode 3 """
s_mode = 3


""" Give out a message containing the name of the sound file playing? 1 = YES | 0 = NO """
""" e.g. if soundfile is  Stirni_-_This_is_my_sound_file.mp3 : """
""" The message would be: """
""" [Sounds by Stirni] You hear: Stirni - This is my sound file """
""" See  # >> Advice: for more information """
s_message = 1

# >> Advice:
""" Advice: If you add a sound to roundendsounds, and your sound name if for example my_name.mp3, """
""" it will give you as message:  [Sounds by Stirni] You hear: my name . So you see, it will replace """
""" _ with a space. """



#########################
#                       #
#     END OF CONFIG     #
#                       #
#########################


# =================================
# >> Do not edit below this line !!
# =================================


#####################
#### © by Stirni ####
#####################


import es
import path
import popuplib
import os
import wave
import sys
import string
import time
import getopt
import gamethread
import cPickle
import random

s_es_gamedir = str(es.ServerVar('eventscripts_gamedir')).replace(os.sep, "/")
s_path = path.path(str(__file__)).dirname().replace(os.sep, "/")
s_basename = str(s_path.split("/")[-1])
"""
s_listdir = os.listdir("%s/sound/%s/saysounds/"%(s_es_gamedir, s_basename))
if len(s_listdir) == 1:
	for s_yourdir in s_listdir:
		s_yourdirectory = s_yourdir
		break
else:
	s_yourdirectory = "saysounds_by_stirni"
	
s_listdir2 = os.listdir("%s/sound/%s/roundendsounds/"%(s_es_gamedir, s_basename))
if len(s_listdir2) == 1:
	for s_yourdir2 in s_listdir2:
		s_yourdirectory2 = s_yourdir2
		break
else:
	s_yourdirectory2 = "roundendsounds_by_stirni"
"""
s_yourdirectory = s_yourdirectory_saysounds
s_yourdirectory2 = s_yourdirectory_roundendsounds
if s_roundendsounds == 1:
	s_resoundslist = []
	s_resoundslistt = []
	s_resoundslistct = []
	s_resoundslistnull = []
	
if s_saysounds == 1:
	s_saysoundssounds = os.listdir("%s/sound/%s/saysounds/%s/"%(s_es_gamedir, s_basename, s_yourdirectory))
	s_saysoundspath = s_basename + "/" + "saysounds" + "/" + s_yourdirectory
	s_varduration = "%s/sound/%s"%(s_es_gamedir, s_saysoundspath)
	s_saysoundslist = s_saysoundssounds[:]
#
if s_roundendsounds == 1:
	s_resoundslist_ = os.listdir("%s/sound/%s/roundendsounds/%s/"%(s_es_gamedir, s_basename, s_yourdirectory2))
	for s_sound__ in s_resoundslist_:
		if s_sound__.endswith('.mp3') or s_sound__.endswith('.wav'):
			s_resoundslist.append(s_sound__)
			s_resoundslistnull.append(s_sound__)
	s_resoundslistt_ = os.listdir("%s/sound/%s/roundendsounds/%s/T/"%(s_es_gamedir, s_basename, s_yourdirectory2))
	for s_sound___ in s_resoundslistt_:
		if s_sound___.endswith('.mp3') or s_sound___.endswith('.wav'):
			s_resoundslistt.append(s_sound___)
	s_resoundslistct_ = os.listdir("%s/sound/%s/roundendsounds/%s/CT/"%(s_es_gamedir, s_basename, s_yourdirectory2))
	for s_sound____ in s_resoundslistct_:
		if s_sound____.endswith('.mp3') or s_sound____.endswith('.wav'):
			s_resoundslistct.append(s_sound____)
	for s_sound_t in s_resoundslistt:
		s_resoundslist.append(s_sound_t)
	for s_sound_ct in s_resoundslistct:
		s_resoundslist.append(s_sound_ct)
	s_resoundspath = s_basename + "/" + "roundendsounds" + "/" + s_yourdirectory2
	s_ifisfileres = s_es_gamedir + "/sound/" + s_resoundspath
	s_musictitle = "__none__"
s_howoftenplay = {}
s_sounddict = {}
s_soundsettings = {}
s_timetonextsound = 0
s_dbpath = s_path + "/s_soundsettings.db"

s_info = es.AddonInfo()
s_info['author'] = "Stirni"
s_info['basename'] = s_basename
s_info['name'] = "Sounds by Stirni"
s_info['var'] = "[%s]"%s_info.name

try:
	s_readdb = open(s_dbpath, 'rb')
	s_soundsettings = cPickle.load(s_readdb)
	s_readdb.close()
except:
	pass


def load():

	msg('loaded!')
	if s_saysounds == 1:
		s_do_download_saysounds()
	
		for userid in es.getUseridList():
			steamid = es.getplayersteamid(userid)
			s_howoftenplay[steamid] = 0
		
		for s_sound_ in s_saysoundslist:
			if s_sound_.endswith('.mp3') or s_sound_.endswith('.wav'):
				s_sounddict[s_sound_.split(".")[0]] = [s_sound_, s_sound_.split(".")[-1]]
			
		if popuplib.exists('s_sounds_stirni'):
			popuplib.delete('s_sounds_stirni')
		s_sounds_stirni = popuplib.easymenu('s_sounds_stirni', None, choice_s_sounds_stirni)
		s_sounds_stirni.settitle('Available SaySounds:')
		for s_av_sounds in s_sounddict.keys():
			s_sounds_stirni.addoption(s_av_sounds, s_av_sounds)
			
	for uid in es.getUseridList():
		sid = es.getplayersteamid(uid)
		if not s_soundsettings.has_key(sid):
			s_soundsettings[steamid] = {'saysounds': 1, 'roundendsounds': 1}
	if s_roundendsounds == 1:
		s_do_download_roundendsounds()
		
		
def choice_s_sounds_stirni(userid, choice, popupname):

	es.server.queuecmd('es_xsexec %s say %s'%(userid, choice))
				
				
def unload():

	msg('unloaded!')
	s_writedb = open(s_dbpath, 'wb')
	cPickle.dump(s_soundsettings, s_writedb)
	s_writedb.close()
	
	
def msg(text):

	es.msg('#multi', '#green%s#lightgreen %s'%(s_info.var, text))
	
	
def tell(userid, text):

	es.tell(userid, '#multi', '#green%s#lightgreen %s'%(s_info.var, text))
	
	
def s_do_download_saysounds():

	for s_downloadsounds in s_saysoundslist:
		if s_downloadsounds.endswith('.mp3') or s_downloadsounds.endswith('.wav'):
			es.stringtable('downloadables',  'sound/%s/%s'%(s_saysoundspath, s_downloadsounds))
			
			
def s_do_download_roundendsounds():
		
	for s_downloadsounds2 in s_resoundslistnull:
		if s_downloadsounds2.endswith('.mp3') or s_downloadsounds2.endswith('.wav'):
			es.stringtable('downloadables',  'sound/%s/%s'%(s_resoundspath, s_downloadsounds2))
	for s_downloadsounds3 in s_resoundslistt:
		if s_downloadsounds3.endswith('.mp3') or s_downloadsounds3.endswith('.wav'):
			es.stringtable('downloadables',  'sound/%s/T/%s'%(s_resoundspath, s_downloadsounds3))
	for s_downloadsounds4 in s_resoundslistct:
		if s_downloadsounds4.endswith('.mp3') or s_downloadsounds4.endswith('.wav'):
			es.stringtable('downloadables',  'sound/%s/CT/%s'%(s_resoundspath, s_downloadsounds4))
	
	
def player_say(event_var):

	userid = event_var['userid']
	text = event_var['text']
	name = es.getplayername(userid)
	steamid = es.getplayersteamid(userid)
	global s_timetonextsound
	
	if s_saysounds == 1:
		if (text in s_sounddict.keys()) and (s_soundsettings[steamid]['saysounds'] == 1):
			if s_howoftenplay[steamid] < s_howoften:
				if s_timetonextsound == 0:
					s_howoftenplay[steamid] += 1
					s_currentsoundpath = '%s/%s'%(s_varduration, s_sounddict[text][0])
					s_soundfileduration = 0
					if s_sounddict[text][-1] == 'wav':
						try:
							s_wopen = wave.open(s_currentsoundpath, 'rb')
							s_soundfileduration = float(s_wopen.getnframes()) / s_wopen.getframerate()
						except:
							s_soundfileduration = 0
						finally:
							s_wopen.close()
					elif s_sounddict[text][-1] == 'mp3':
						try:
							s_mp3info = mp3info(s_currentsoundpath)
							s_soundfileduration = s_mp3info['MM'] * 60 + s_mp3info['SS']
						except:
							s_soundfileduration = 0
					for human in filter(lambda player: (not es.isbot(player)), es.getUseridList()):
						if s_soundsettings[es.getplayersteamid(human)]['saysounds'] == 1:
							es.playsound(human, s_saysoundspath + "/" + s_sounddict[text][0], 1.0)
							tell(human, '#darkgreen%s#lightgreen played sound #green%s#lightgreen! Length: %s sec.'%(name, text, round(s_soundfileduration)))
					s_timetonextsound = s_soundfileduration
					gamethread.delayedname(s_timetonextsound, 'timetonextsound', s_mathfunc, ())
				else:
					tell(userid, 'You have to wait, until this sound is over. Then you can play another one!')
			else:
				if s_howoften == 1:
					tell(userid, 'You have already played #darkgreena sound#lightgreen!')
				if s_howoften >= 2:
					tell(userid, 'You have already played #darkgreen%s sounds#lightgreen!'%s_howoftenplay[steamid])
	
		if text == s_saysoundlist:
			popuplib.send('s_sounds_stirni', userid)
					
		if text == s_saysoundsettings:
			s_saysounds_settings(userid)
			
	if s_roundendsounds == 1:
		if text == s_ressettings:
			s_roundendsounds_settings(userid)
			
			
def s_saysounds_settings(userid):

	steamid = es.getplayersteamid(userid)
	
	if popuplib.exists('s_sounds_stirni_settings'):
		popuplib.delete('s_sounds_stirni_settings')
	s_sounds_stirni_settings = popuplib.create('s_sounds_stirni_settings')
	s_sounds_stirni_settings.addline('SaySounds Settings:')
	s_sounds_stirni_settings.addline('----------------------------------------')
	if s_soundsettings[steamid]['saysounds'] == 1:
		s_sounds_stirni_settings.addline('->1. SaySounds [ON  [√]]')
	if s_soundsettings[steamid]['saysounds'] == 0:
		s_sounds_stirni_settings.addline('->1. SaySounds [OFF [ ]]')
	s_sounds_stirni_settings.addline('----------------------------------------')
	s_sounds_stirni_settings.addline('0. Close')
	s_sounds_stirni_settings.menuselect = choice_s_sounds_stirni_settings
	s_sounds_stirni_settings.send(userid)
	
	
def choice_s_sounds_stirni_settings(userid, choice, popupname):

	steamid = es.getplayersteamid(userid)
	if choice == 1:
		if s_soundsettings[steamid]['saysounds'] == 0:
			s_soundsettings[steamid]['saysounds'] = 1
		else:
			if s_soundsettings[steamid]['saysounds'] == 1:
				s_soundsettings[steamid]['saysounds'] = 0
		s_saysounds_settings(userid)
		
		
def s_roundendsounds_settings(userid):

	steamid = es.getplayersteamid(userid)
	
	if popuplib.exists('s_sounds_stirni_settings2'):
		popuplib.delete('s_sounds_stirni_settings2')
	s_sounds_stirni_settings2 = popuplib.create('s_sounds_stirni_settings2')
	s_sounds_stirni_settings2.addline('RoundEndSounds Settings:')
	s_sounds_stirni_settings2.addline('----------------------------------------')
	if s_soundsettings[steamid]['roundendsounds'] == 1:
		s_sounds_stirni_settings2.addline('->1. RoundEndSounds [ON  [√]]')
	if s_soundsettings[steamid]['roundendsounds'] == 0:
		s_sounds_stirni_settings2.addline('->1. RoundEndSounds [OFF [ ]]')
	s_sounds_stirni_settings2.addline('----------------------------------------')
	s_sounds_stirni_settings2.addline('0. Close')
	s_sounds_stirni_settings2.menuselect = choice_s_sounds_stirni_settings2
	s_sounds_stirni_settings2.send(userid)
	
	
def choice_s_sounds_stirni_settings2(userid, choice, popupname):

	steamid = es.getplayersteamid(userid)
	if choice == 1:
		if s_soundsettings[steamid]['roundendsounds'] == 0:
			s_soundsettings[steamid]['roundendsounds'] = 1
		else:
			if s_soundsettings[steamid]['roundendsounds'] == 1:
				s_soundsettings[steamid]['roundendsounds'] = 0
		s_roundendsounds_settings(userid)
					
					
def s_mathfunc():

	global s_timetonextsound
	s_timetonextsound = 0
				
				
def es_map_start(event_var):

	if s_saysounds == 1:
		s_do_download_saysounds()
	if s_roundendsounds == 1:
		s_do_download_roundendsounds()
	
	
def round_end(event_var):

	winnerteam = str(event_var['winner'])
	global s_timetonextsound
	if s_saysounds == 1:
		for p in es.getUseridList():
			s_howoftenplay[es.getplayersteamid(p)] = 0
		gamethread.cancelDelayed('timetonextsound')
		s_timetonextsound = 0
		
	if s_roundendsounds == 1:
		s_musictitle = "__none__"
		if s_mode == 1:
			s_musictitle = random.choice(s_resoundslist)
		elif s_mode == 2:
			if winnerteam == "2":
				s_musictitle = random.choice(s_resoundslistt)
			elif winnerteam == "3":
				s_musictitle = random.choice(s_resoundslistct)
			else:
				print "%s No winner detected, going to Mode 3"%(s_info.var)
				s_musictitle = random.choice(s_resoundslistnull)
		elif s_mode == 3:
			s_musictitle = random.choice(s_resoundslistnull)
		else:
			s_musictitle = random.choice(s_resoundslistnull)
		for human2 in filter(lambda player: (not es.isbot(player)) and (s_soundsettings[es.getplayersteamid(player)]['roundendsounds'] == 1), es.getUseridList()):
			if s_mode == 1:
				if os.path.isfile("%s/%s"%(s_ifisfileres, s_musictitle)):
					es.playsound(human2, s_resoundspath + "/" + s_musictitle, 1.0)
				elif os.path.isfile("%s/T/%s"%(s_ifisfileres, s_musictitle)):
					es.playsound(human2, s_resoundspath + "/T/" + s_musictitle, 1.0)
				elif os.path.isfile("%s/CT/%s"%(s_ifisfileres, s_musictitle)):
					es.playsound(human2, s_resoundspath + "/CT/" + s_musictitle, 1.0)
				if s_message == 1:
					tell(human2, 'You hear: #default%s'%s_musictitle.split(".")[0].replace("_", " "))
			elif s_mode == 2:
				if winnerteam == "2":
					if os.path.isfile("%s/T/%s"%(s_ifisfileres, s_musictitle)):
						es.playsound(human2, s_resoundspath + "/T/" + s_musictitle, 1.0)
					if s_message == 1:
						tell(human2, 'You hear: #default%s'%s_musictitle.split(".")[0].replace("_", " "))
				elif winnerteam == "3":
					if os.path.isfile("%s/CT/%s"%(s_ifisfileres, s_musictitle)):
						es.playsound(human2, s_resoundspath + "/CT/" + s_musictitle, 1.0)
					if s_message == 1:
						tell(human2, 'You hear: #default%s'%s_musictitle.split(".")[0].replace("_", " "))
				else:
					if os.path.isfile("%s/%s"%(s_ifisfileres, s_musictitle)):
						es.playsound(human2, s_resoundspath + "/" + s_musictitle, 1.0)
					if s_message == 1:
						tell(human2, 'You hear: #default%s'%s_musictitle.split(".")[0].replace("_", " "))
			elif s_mode == 3:
				if os.path.isfile("%s/%s"%(s_ifisfileres, s_musictitle)):
					es.playsound(human2, s_resoundspath + "/" + s_musictitle, 1.0)
				if s_message == 1:
					tell(human2, 'You hear: #default%s'%s_musictitle.split(".")[0].replace("_", " "))
	
	
def round_start(event_var):

	global s_timetonextsound
	if s_saysounds == 1:
		for p in es.getUseridList():
			s_howoftenplay[es.getplayersteamid(p)] = 0
		gamethread.cancelDelayed('timetonextsound')
		s_timetonextsound = 0
	
	
def es_player_validated(event_var):

	steamid = event_var['networkid']
	if s_saysounds == 1:
		s_howoftenplay[steamid] = 0
	if not s_soundsettings.has_key(steamid):
		s_soundsettings[steamid] = {'saysounds': 1, 'roundendsounds': 1}
		
		

mp3_genres = ['Blues',
    'Classic Rock',
    'Country',
    'Dance',
    'Disco',
    'Funk',
    'Grunge',
    'Hip-Hop',
    'Jazz',
    'Metal',
    'New Age',
    'Oldies',
    'Other',
    'Pop',
    'R&B',
    'Rap',
    'Reggae',
    'Rock',
    'Techno',
    'Industrial',
    'Alternative',
    'Ska',
    'Death Metal',
    'Pranks',
    'Soundtrack',
    'Euro-Techno',
    'Ambient',
    'Trip-Hop',
    'Vocal',
    'Jazz+Funk',
    'Fusion',
    'Trance',
    'Classical',
    'Instrumental',
    'Acid',
    'House',
    'Game',
    'Sound Clip',
    'Gospel',
    'Noise',
    'AlternRock',
    'Bass',
    'Soul',
    'Punk',
    'Space',
    'Meditative',
    'Instrumental Pop',
    'Instrumental Rock',
    'Ethnic',
    'Gothic',
    'Darkwave',
    'Techno-Industrial',
    'Electronic',
    'Pop-Folk',
    'Eurodance',
    'Dream',
    'Southern Rock',
    'Comedy',
    'Cult',
    'Gangsta',
    'Top 40',
    'Christian Rap',
    'Pop/Funk',
    'Jungle',
    'Native American',
    'Cabaret',
    'New Wave',
    'Psychadelic',
    'Rave',
    'Showtunes',
    'Trailer',
    'Lo-Fi',
    'Tribal',
    'Acid Punk',
    'Acid Jazz',
    'Polka',
    'Retro',
    'Musical',
    'Rock & Roll',
    'Hard Rock', ]

winamp_genres = mp3_genres + \
['Folk',
    'Folk-Rock',
    'National Folk',
    'Swing',
    'Fast Fusion',
    'Bebob',
    'Latin',
    'Revival',
    'Celtic',
    'Bluegrass',
    'Avantgarde',
    'Gothic Rock',
    'Progressive Rock',
    'Psychedelic Rock',
    'Symphonic Rock',
    'Slow Rock',
    'Big Band',
    'Chorus',
    'Easy Listening',
    'Acoustic',
    'Humour',
    'Speech',
    'Chanson',
    'Opera',
    'Chamber Music',
    'Sonata',
    'Symphony',
    'Booty Bass',
    'Primus',
    'Porn Groove',
    'Satire',
    'Slow Jam',
    'Club',
    'Tango',
    'Samba',
    'Folklore',
    'Ballad',
    'Power Ballad',
    'Rhythmic Soul',
    'Freestyle',
    'Duet',
    'Punk Rock',
    'Drum Solo',
    'Acapella',
    'Euro-House',
    'Dance Hall']

t_bitrate = [[[0,
    32,
    48,
    56,
    64,
    80,
    96,
    112,
    128,
    144,
    160,
    176,
    192,
    224,
    256],
    [0,
        8,
        16,
        24,
        32,
        40,
        48,
        56,
        64,
        80,
        96,
        112,
        128,
        144,
        160],
    [0,
        8,
        16,
        24,
        32,
        40,
        48,
        56,
        64,
        80,
        96,
        112,
        128,
        144,
        160]],
    [[0,
        32,
        64,
        96,
        128,
        160,
        192,
        224,
        256,
        288,
        320,
        352,
        384,
        416,
        448],
        [0,
            32,
            48,
            56,
            64,
            80,
            96,
            112,
            128,
            160,
            192,
            224,
            256,
            320,
            384],
        [0,
            32,
            40,
            48,
            56,
            64,
            80,
            96,
            112,
            128,
            160,
            192,
            224,
            256,
            320]]]

t_sampling_freq = [[22050,
    24000,
    16000],
    [44100,
        48000,
        32000]]

frequency_tbl = {
    0: 22050, 1: 24000, 2: 16000, 3: 44100, 4: 48000, 5: 32000, 6: 64000
    }


def getword(fp, off):
    fp.seek(off, 0)
    word = fp.read(4)
    return word


def get_l4(s):
    return reduce(lambda a, b: ((a << 8) + b), map(long, map(ord, s)))


def get_xing_header(f):
    where = f.tell()

    try:
        f.seek(0)
        b = f.read(8192)
        i = string.find(b, 'Xing')

        if i > 0:
            # 32-bit fields; "Xing", flags, frames, bytes, 100 toc
            i = i + 4
            flags = get_l4(b[i: i + 4])
            i = i + 4
            frames = get_l4(b[i: i + 4])
            i = i + 4
            bytes = get_l4(b[i: i + 4])
            i = i + 4
            return flags, frames, bytes

        else:
            return None

    finally:
        f.seek(where)

MPG_MD_STEREO = 0
MPG_MD_JOINT_STEREO = 1
MPG_MD_DUAL_CHANNEL = 2
MPG_MD_MONO = 3


def get_newhead(word):
    word = get_l4(word)

    if (word & (1 << 20)):
        if (word & (1 << 19)):
            lsf = 0

        else:
            lsf = 1
        mpeg25 = 0

    else:
        lsf = 1
        mpeg25 = 1
    lay = 4 - ((word >> 17) & 3)

    if mpeg25:
        sampling_frequency = 6 + ((word >> 10) & 3)

    else:
        sampling_frequency = ((word >> 10) & 3) + (lsf * 3)
    error_protection = ((word >> 16) & 1) ^ 1
    bitrate_index = (word >> 12) & 0xf
    padding = ((word >> 9) & 0x1)
    extension = ((word >> 8) & 0x1)
    mode = ((word >> 6) & 0x3)
    mode_ext = ((word >> 4) & 0x3)
    copyright = ((word >> 3) & 0x1)
    original = ((word >> 2) & 0x1)
    emphasis = word & 0x3

    if mode == MPG_MD_MONO:
        stereo = 1

    else:
        stereo = 2

    return locals()
    import pprint
    pprint.pprint(locals())


def get_head(word):
    if len(word) != 4:
        return {}
    l = (ord(word[0]) << 24 | ord(word[1]) << 16 |
        ord(word[2]) << 8 | ord(word[3]))

    id = (l >> 19) & 1
    layer = (l >> 17) & 3
    protection_bit = (l >> 16) & 1
    bitrate_index = (l >> 12) & 15
    sampling_freq = (l >> 10) & 3
    padding_bit = (l >> 9) & 1
    private_bit = (l >> 8) & 1
    mode = (l >> 6) & 3
    mode_extension = (l >> 4) & 3
    copyright = (l >> 3) & 1
    original = (l >> 2) & 1
    emphasis = (l >> 0) & 1
    version_index = (l >> 19) & 3
    bytes = l

    ##   for k,v in vars().items():
    ##     print k,v

    try:
        bitrate = t_bitrate[id][3 - layer][bitrate_index]

    except IndexError:
        bitrate = 0

    try:
        fs = t_sampling_freq[id][sampling_freq]

    except IndexError:
        fs = 0

    return vars()


def is_mp3(h):
    #if h['bytes'] == -1: return 0
    if not (h['bitrate_index'] == 0 or           \
    h['version_index'] == 1 or                   \
    ((h['bytes'] & 0xFFE00000) != 0xFFE00000) or \
    (not h['fs']) or                             \
    (not h['bitrate'])):
        return 1
    return 0


def get_v2head(fp):
    fp.seek(0, 0)
    word = fp.read(3)

    if word != "ID3":
        return 0

    bytes = fp.read(2)
    major_version = ord(bytes[0])
    minor_version = ord(bytes[1])

    version = "ID3v2.%d.%d" % (major_version, minor_version)
    bytes = fp.read(1)
    unsync = (ord(bytes) >> 7) & 1
    ext_header = (ord(bytes) >> 6) & 1
    experimental = (ord(bytes) >> 5) & 1

    bytes = fp.read(4)
    tagsize = 0

    for i in range(4):
        tagsize = tagsize + ord(bytes[3 - i]) * 128 * i

    if ext_header:
        ext_header_size = ext_header_size + 10
        bytes = fp.read(4)

    return vars()


def mp3info(fn):
    off = 0
    eof = 0
    h = 0
    i = 0
    tot = 4096

    if os.stat(fn)[6] == 0:
        return {}

    fp = open(fn)
    word = getword(fp, off)

    if off == 0:
        id3v2 = get_v2head(fp)

        if id3v2:
            off = off + id3v2['tagsize']
            tot = tot + off
            word = getword(fp, off)

    nh = get_newhead(word)

    vbr = 0
    xh = get_xing_header(fp)

    if xh:
        flags, xing_frames, xing_bytes = xh

        if (flags & 0x08):
            vbr = 1
        #print 'xing: frames:%d bytes:%d' % (int(xing_frames), int(xing_bytes))

        if vbr:
            tpf = float([0,
                384,
                1152,
                1152][int(nh['lay'])])

            tpf = tpf / ([44100,
                48000,
                32000,
                22050,
                24000,
                16000,
                11025,
                12000,
                8000][int(nh['sampling_frequency'])] << nh['lsf'])

            print 'VBR average bit-rate:', int((xing_bytes * 8.) / (
                                            tpf * xing_frames * 1000))

    while 1:
        h = get_head(word)

        if not h:
            break
        off = off + 1
        word = getword(fp, off)

        if off > tot:
            print "BAD FILE", fn, os.stat(fn)[6]
            #os.unlink(fn)
            return {}

        if is_mp3(h):
            break

    fp.seek(0, 2)
    eof = fp.tell()

    try:
        fp.seek(-128, 2)

    except IOError, reason:
        return {}

    if h['id']:
        h['mean_frame_size'] = (144000. * h['bitrate']) / h['fs']

    else:
        h['mean_frame_size'] = (72000. * h['bitrate']) / h['fs']

    h['layer'] = h['mode']
    h['freq_idx'] = 3 * h['id'] + h['sampling_freq']

    h['length'] = ((1.0 * eof - off) / h['mean_frame_size']) * (
                (115200. / 2) * (1. + h['id'])) / (1.0 * h['fs'])
    h['secs'] = int(h['length'] / 100)

    i = {}
    i['VERSION'] = h['id']
    i['MM'] = int(h['secs'] / 60)
    i['SS'] = h['secs'] % 60
    i['STEREO'] = not (h['mode'] == 3)

    if h['layer'] >= 0:
        if h['layer'] == 3:
            i['LAYER'] = 2

        else:
            i['LAYER'] = 3

    else:
        i['LAYER'] = ''
    i['MODE'] = h['mode']
    i['COPYRIGHT'] = h['copyright']

    if h['bitrate'] >= 0:
        i['BITRATE'] = h['bitrate']

    else:
        i['BITRATE'] = ''

    if h['freq_idx'] >= 0:
        i['FREQUENCY'] = frequency_tbl[h['freq_idx']]

    else:
        i['FREQUENCY'] = ''

    return i


def get_mp3tag(fn):
    if os.stat(fn)[6] == 0:
        return {}

    try:
        fp = open(fn)

    except IOError, reason:
        return {}

    try:
        fp.seek(-128, 2)

    except IOError, reason:
        return {}

    line = None

    while 1:
        l = fp.readline()

        if not l:
            break
        line = l

    id = {}

    if line[:3] == 'TAG':
        v1 = 1
        i = 0
        j = i + 3
        #id['d1'] = string.strip(line[i:j])
        i = j
        j = i + 30
        id['TITLE'] = string.strip(line[i:j])
        i = j
        j = i + 30
        id['ARTIST'] = string.strip(line[i:j])
        i = j
        j = i + 30
        id['ALBUM'] = string.strip(line[i:j])
        i = j
        j = i + 4
        id['YEAR'] = string.strip(line[i:j])
        i = j
        j = i + 28
        id['COMMENT'] = string.strip(line[i:j])

        genre = ord(line[-1])

        try:
            id['GENRE'] = winamp_genres[ord(line[-1])]

        except IndexError:
            id['GENRE'] = "Unknown"

    return id


def Categorize(fn):
    i1 = mp3info(fn)
    i2 = get_mp3tag(fn)

    path1 = "cats/GENRE_ARIST/%s/%s" % (i2.get('GENRE', "Unknown"),
                                        i2.get('ARTIST', "Unknown"))
    path2 = "cats/GENRE/%s" % (i2.get('GENRE', "Unknown"))
    path3 = "cats/ARIST/%s" % (i2.get('ARTIST', "Unknown"))

    path1 = string.replace(path1, "\0", "_")
    path1 = string.replace(path1, " ", "_")
    path2 = string.replace(path2, "\0", "_")
    path2 = string.replace(path2, " ", "_")
    path3 = string.replace(path3, "\0", "_")
    path3 = string.replace(path3, " ", "_")

    if not os.path.isdir(path1):
        os.makedirs(path1)

    if not os.path.isdir(path2):
        os.makedirs(path2)

    if not os.path.isdir(path3):
        os.makedirs(path3)
    base, ffn = os.path.split(fn)

    try:
        os.symlink(fn, os.path.join(path1, ffn))

    except:
        pass

    try:
        os.symlink(fn, os.path.join(path2, ffn))

    except:
        pass

    try:
        os.symlink(fn, os.path.join(path3, ffn))

    except:
        pass


def usage(progname):
    print __doc__ % vars()


def main(argv, stdout, environ):
    progname = argv[0]
    list, args = getopt.getopt(argv[1:], "", ["help",
        "cat"])

    if len(args) == 0:
        usage(progname)
        return

    for field, val in list:
        if field == "--help":
            usage(progname)
            return

        elif field == "--cat":
            for fn in args:
                Categorize(fn)
            return

    for fn in args:
        print fn
        i1 = mp3info(fn)

        for k, v in i1.items():
            print k, v

        i2 = get_mp3tag(fn)

        for k, v in i2.items():
            print k, v
        print

if __name__ == "__main__":
    #main (sys.argv, sys.stdout, os.environ)
    info = mp3info(
        'E:/Music/LCD Soundsystem - Get Innocuous (Soulwax remix).mp3')
    seconds = info['MM'] * 60 + info['SS']
    print seconds


#####################
#### © by Stirni ####
#####################